package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.AsymmetricCipherKeyPair;
import cn.com.infosec.crypto.AsymmetricCipherKeyPairGenerator;
import cn.com.infosec.crypto.KeyGenerationParameters;
import cn.com.infosec.crypto.params.GOST3410KeyGenerationParameters;
import cn.com.infosec.crypto.params.GOST3410Parameters;
import cn.com.infosec.crypto.params.GOST3410PrivateKeyParameters;
import cn.com.infosec.crypto.params.GOST3410PublicKeyParameters;
import java.math.BigInteger;
import java.security.SecureRandom;

public class GOST3410KeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
   private static final BigInteger ZERO = BigInteger.valueOf(0L);
   private GOST3410KeyGenerationParameters param;

   public void init(KeyGenerationParameters param) {
      this.param = (GOST3410KeyGenerationParameters)param;
   }

   public AsymmetricCipherKeyPair generateKeyPair() {
      GOST3410Parameters var1;
      GOST3410Parameters var10000 = var1 = this.param.getParameters();
      SecureRandom var6 = this.param.getRandom();
      BigInteger var2 = var10000.getQ();
      BigInteger var3 = var10000.getP();
      BigInteger var4 = var10000.getA();

      BigInteger var5;
      BigInteger var10;
      do {
         do {
            var10 = var5 = new BigInteger;
            var10.<init>(256, var6);
         } while(var10.equals(ZERO));
      } while(var5.compareTo(var2) >= 0);

      BigInteger var7 = var4.modPow(var5, var3);
      GOST3410PublicKeyParameters var9;
      var9 = new GOST3410PublicKeyParameters.<init>(var7, var1);
      GOST3410PrivateKeyParameters var8;
      var8 = new GOST3410PrivateKeyParameters.<init>(var5, var1);
      return new AsymmetricCipherKeyPair(var9, var8);
   }
}
